#!/bin/sh

# if you can't install hscurses, uncomment this:
# WITHOUT="Console"

ALL_MODULES="Small Concurrency Exception Metadata Random CrudeIO Console"
MODULES=""

for MODULE in $ALL_MODULES; do
  ADD_IT=yes
  for EXCEPT in $WITHOUT; do
    if [ "${EXCEPT}x" = "${MODULE}x" ]; then
      ADD_IT=no
    fi
  done
  if [ "${ADD_IT}" = "yes" ]; then
    MODULES="${MODULES} ${MODULE}"
  fi
done

cat >Robin/Builtins.hs <<EOF
module Robin.Builtins (builtinModules) where

-- This file was automatically generated by build.sh.
-- Edit at your own risk!

import qualified Robin.Core
EOF

for MODULE in $MODULES; do
    echo >>Robin/Builtins.hs "import qualified Robin.${MODULE}"
done

cat >>Robin/Builtins.hs <<EOF

builtinModules = [
EOF

for MODULE in $MODULES; do
    echo >>Robin/Builtins.hs "    (Robin.${MODULE}.moduleId, Robin.${MODULE}.moduleDef),"
done

cat >>Robin/Builtins.hs <<EOF
    (Robin.Core.moduleId, Robin.Core.moduleDef)
  ]
EOF

PACKAGES=""
for MODULE in $MODULES; do
  if [ "${MODULE}x" = "Consolex" ]; then
    PACKAGES="${PACKAGES} -package hscurses"
  fi
done

mkdir -p bin
ghc ${PACKAGES} --make Main.lhs -o bin/robin
RESULT=$?
rm -f *.o *.hi Robin/*.o Robin/*.hi
exit $RESULT
